// -*- MaTX -*-

// sim00005.mm: tmd00005.{h,mm} ΥƥȤΤΥߥ졼
//
//   Originally written by KIYOTA Hiromitsu <1999/01/04>
//   Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
//
// RCS: $Id: sim00005.mm,v 1.4 1999/05/31 03:43:05 kiyota Exp $

// Local options
//#define NOPLOT
//#define MULTIPLOT

// These are required #definitions.
#define TMD00005_USER_H "sim00005.h"
#define TMD00005_USER_MM "sim00005.mm"

// TMD00005_USER_H  #include 롣
#include "tmd00005.h"

Matrix F;

Func void
main()
{
  Matrix TC, XC, UC;
  Matrix link_eqs();
#ifndef NOPLOT
  List names;
  Integer i;
#ifdef MULTIPLOT
  Integer hmultiplot(...) require "hplot.mm";
#endif /* MULTIPLOT */
#endif /* ! NOPLOT */

//  init_tmd00005(1); // Υߥʥѥ᡼Υߥ졼
  init_tmd00005(); // ѥ᡼ư륷ߥ졼

  F = Optimal(tmd00005(A), tmd00005(B2),
	      diag([1.0], [10.0], [10.0], [100.0]), [1.0]);
  
  {TC, XC, UC} = Ode45Auto(0.0, 1.0,
#ifndef TMD00005_USER_DIFF
			   [0.0, 5e-1, 0.0, -1e-1]',
#else /* TMD00005_USER_DIFF */
			   [[0.0, 5e-1, 0.0, -1e-1],
			    [0.0, 0.0]]', // ưŪν
#endif /* ! TMD00005_USER_DIFF */
			   diff_tmd00005, link_eqs);
  print [[TC][XC][UC]] >> "sim.mat";

#ifndef NOPLOT
  names = {"dot_thetaM", "thetaM(=z)", "dot_thetaT", "thetaT(=y)",
	   "TD(=w)", "v(=u)", "-", "-"};

#ifndef MULTIPLOT
   for (i = 1; i <= length(names); ++i)
     {
       if (names(i, String) == "-") { continue; }
       mgplot_grid(i, 1);
       mgplot(i, TC(1,:), [[XC][UC]](i,:), {names(i, String)});
     }
#else /* MULTIPLOT */
  hmultiplot(1, TC, [[XC][UC]], names);
#endif /* ! MULTIPLOT */
  pause;
#endif /* ! NOPLOT */
}


Func Matrix
link_eqs(t, xx)
     Real t;
     Matrix xx;
{
  Matrix wuzy;
  static Integer running;
  static Matrix w, u;
  Matrix x, zy;

  if (running == 0) // ߥ졼󳫻ϻ
    {
      wuzy = Z(TMD00005_DIM_ALL_IOS,1);
      w = chop_input_w_tmd00005(wuzy);
      u = chop_input_u_tmd00005(wuzy);
      running = 1;
    }

  x = chop_state_tmd00005(xx);
  zy = output_tmd00005(t, x, [[w][u]]);
  w = [0.0]; //  TD
  u = F*x; // ǤϾ֤ΤäƤ뤳Ȥˤ롣;-)

  wuzy = [[w]
	  [u]
	  [zy]];
  return wuzy;
}


#ifdef TMD00005_USER_DIFF
// ߡưŪ
Func Matrix
TMD00005_USER_DIFF(t, xx, wul)
     Real t;
     Matrix xx, wul;
{
  Matrix x, z, w, u; // z ϤǤϴ¬ξ֤ʤ

  x = chop_state_tmd00005(xx);
  z = chop_other_state_tmd00005(xx);
  w = chop_input_w_tmd00005(wul);
  u = chop_input_u_tmd00005(wul);

  return [1.0, -1.0]'; // ߡνíܤʥʥߥ ;-)
}
#endif /* TMD00005_USER_DIFF */
