/* -*- MaTX -*-
 *
 * tmd00005.mm: TMD No. tmd00005 (ưϤοưθַᵡ)Υǥ
 *
 *  Originally written by KIYOTA Hiromitsu <1999/01/04>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00005.mm,v 1.8 1999/06/29 03:49:19 kiyota Exp $
 */

#ifndef _TMD00005_MM
#define _TMD00005_MM

#ifndef TMD_EXTERN
#define TMD_EXTERN extern
#endif /* ! TMD_EXTERN */
#include "tmd00005.h"

// some definitions for local alist
#define _TMD_LALIST {"_tmd00005"}
#define _TMD_NOM_FLAG "nominal_flag"

// just for my convinience B)
#define tmd5(var) tmd00005(var)

Func void
init_tmd00005(nominal_flag, const_params_flag, ...)
     Integer nominal_flag, const_params_flag;
{
#ifndef TMD00005_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00005_DISABLE_HALIST */
  Real a1, a2, a3, a4, a5, a6, a7, a8, b1, b2;

  switch (nargs)
    {
    case 2:
      break;
    case 0:
      nominal_flag = 0; // ǥե: ѥ᡼ư
    case 1:
      const_params_flag = 0; // ǥե: ѥ᡼̤
      break;
    default:
      error("init_tmd00005(): Incorrect number of arguments. (nargs=%d)\n", nargs);
      break;
    }

  // ѥ᡼ư̵ͭ
#ifndef TMD00005_DISABLE_HALIST
  if (halist({_TMD_LALIST, "exists"}) == {})  // if not exist
    {
      halist({_TMD_LALIST, "clear"});  // new alist
    }
  halist(_TMD_LALIST, {{_TMD_NOM_FLAG, nominal_flag}});
#else /* TMD00005_DISABLE_HALIST */
  tmd00005_flag = nominal_flag;
#endif /* ! TMD00004_DISABLE_HALIST */

  if (const_params_flag == 0)
    {
      // ʪѥ᡼
      tmd5(JM) = 1.22105e-4; /* kgm^2 */	// ⡼¦ʡ
      tmd5(DM) = 9.0413e-5; /* Nms/rad */	// ⡼¦Ǵ
      tmd5(JT) = 4.37025e-5; /* kgm^2 */	// ¦ʡ
      tmd5(DT) = 4.22655e-4; /* Nms/rad */	// ¦Ǵ
      tmd5(KC) = 2.74217; /* Nm/rad */		// åץ󥰥Х
      tmd5(DC) = 8.77578e-4; /* Nms/rad */	// åץǴ
      tmd5(KV) = 1.9981e-1; /* Nm/V */		// ȥ륯
      tmd5(l) = 0.01; /* m */			// ꡼

      // ư礭
      tmd5(f1) = 7.24824e-2;
      tmd5(f2) = 7.00423e-2;
      tmd5(f3) = 8.15573e-2;
      tmd5(f4) = 7.00423e-2;
      tmd5(f5) = 4.48240e-2;
      tmd5(f6) = 2.82000e-2;
      tmd5(f7) = 9.55900e-2;
      tmd5(f8) = 2.82000e-2;
      tmd5(f9) = 8.99232e-2;
      tmd5(f10) = 1.0000e-6;
    }

  a1 = -tmd5(DM)/tmd5(JM) - tmd5(DC)/tmd5(JM);
  a2 = -tmd5(KC)/tmd5(JM);
  a3 = tmd5(DC)/tmd5(JM);
  a4 = tmd5(KC)/tmd5(JM);
  a5 = tmd5(DC)/tmd5(JT);
  a6 = tmd5(KC)/tmd5(JT);
  a7 = -tmd5(DT)/tmd5(JT) - tmd5(DC)/tmd5(JT);
  a8 = -tmd5(KC)/tmd5(JT);
  b1 = -1.0/tmd5(JT);
  b2 = tmd5(KV)/tmd5(JM);

  tmd5(A) = [[a1, a2, a3, a4]
	     [ 1,  0,  0,  0]
	     [a5, a6, a7, a8]
	     [ 0,  0,  1,  0]];
  tmd5(B1) = [ 0,  0, b1,  0]';
  tmd5(B2) = [b2,  0,  0,  0]';
  tmd5(C1) = [ 0,  0,  0,  1];
  tmd5(C2) = [ 0,  1,  0,  0];
#ifdef TMD00005_STRICT_MEMORY_MANAGEMENT
  if (nominal_flag == 0) // ѥ᡼ưΤ(ʸɤ)
    {
#endif /* TMD00005_STRICT_MEMORY_MANAGEMENT */
      tmd5(D11) = [0];  tmd5(D12) = [0];
      tmd5(D21) = [0];  tmd5(D22) = [0];
#ifdef TMD00005_STRICT_MEMORY_MANAGEMENT
    }
#endif /* TMD00005_STRICT_MEMORY_MANAGEMENT */
}


// ѥ᡼ưλִؿ delta* 桼Ƥ褤
#ifndef TMD00005_DOES_NOT_DEFINE_ANY_DELTAS

#ifdef TMD00005_DELTAS_RETURN_CONSTANT_UNITY
#define TMD00005_DELTAS_ZERO 1.0
#else /* ! TMD00005_DELTAS_RETURN_CONSTANT_UNITY */
#define TMD00005_DELTAS_ZERO 0.0
#endif /* TMD00005_DELTAS_RETURN_CONSTANT_UNITY */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA1
Func Real
delta1_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA1_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA1_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA1_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA1 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA2
Func Real
delta2_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA2_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA2_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA2_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA2 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA3
Func Real
delta3_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA3_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA3_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA3_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA3 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA4
Func Real
delta4_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA4_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA4_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA4_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA4 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA5
Func Real
delta5_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA5_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA5_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA5_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA5 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA6
Func Real
delta6_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA6_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA6_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA6_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA6 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA7
Func Real
delta7_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA7_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA7_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA7_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA7 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA8
Func Real
delta8_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA8_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA8_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA8_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA8 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA9
Func Real
delta9_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA9_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA9_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA9_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA9 */

#ifndef TMD00005_DOES_NOT_DEFINE_DELTA10
Func Real
delta10_tmd00005(t)
     Real t;
{
#ifndef TMD00005_DELTA10_RETURNS_CONSTANT_UNITY
  return TMD00005_DELTAS_ZERO;
#else /* TMD00005_DELTA10_RETURNS_CONSTANT_UNITY */
  return 1.0;
#endif /* ! TMD00005_DELTA10_RETURNS_CONSTANT_UNITY */
}
#endif /* ! TMD00005_DOES_NOT_DEFINE_DELTA10 */

#undef TMD00005_DELTAS_ZERO

#endif /* ! TMD00005_DOES_NOT_DEFINE_ANY_DELTAS */


Func Matrix
diff_tmd00005(t, xx, wul)
     Real t;
     Matrix xx, wul; // wul = w, u and log ;-)
{
  Matrix dxx;
#ifndef TMD00005_DISABLE_HALIST
  List halist(...);
#endif /* ! TMD00005_DISABLE_HALIST */
  Matrix dx, x, w, u;
  Real delta1_tmd00005(), delta2_tmd00005(), delta3_tmd00005();
  Real delta4_tmd00005(), delta5_tmd00005(), delta6_tmd00005();
  Real delta7_tmd00005(), delta8_tmd00005(), delta9_tmd00005();
#ifdef TMD00005_USER_DIFF
  Matrix TMD00005_USER_DIFF();
#endif /* TMD00005_USER_DIFF */
  Matrix deltas1, deltas2;
  // btw, is it correct that the plural of delta is deltas? ;)

  x = chop_state_tmd00005(xx);
  w = chop_input_w_tmd00005(wul);
  u = chop_input_u_tmd00005(wul);

#ifndef TMD00005_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_NOM_FLAG}) == {0}) // ѥ᡼ư
#else /* TMD00005_DISABLE_HALIST */
  if (tmd00005_flag == 0) // ѥ᡼ư
#endif /* ! TMD00005_DISABLE_HALIST */
    {
      deltas1 = [delta1_tmd00005(t)*tmd5(f1), delta2_tmd00005(t)*tmd5(f2),
		 delta3_tmd00005(t)*tmd5(f3), delta4_tmd00005(t)*tmd5(f4)]';
      deltas2 = [delta5_tmd00005(t)*tmd5(f5), delta6_tmd00005(t)*tmd5(f6),
		 delta7_tmd00005(t)*tmd5(f7), delta8_tmd00005(t)*tmd5(f8)]';

      dx = ((tmd5(A) + [[[deltas1*[tmd5(A)(1,1:4)]](1,1:4)]
			[Z(1,4)]
			[[deltas2*[tmd5(A)(3,1:4)]](3,1:4)]
			[Z(1,4)]])*x
	    + tmd5(B1)*w
	    + (tmd5(B2) + [tmd5(B2)(1)*delta9_tmd00005(t)*tmd5(f9),0,0,0]')*u);
    }
  else // Υߥʥ
    {
      dx = tmd5(A)*x + tmd5(B1)*w + tmd5(B2)*u;
    }

  dxx = [[dx]
#ifdef TMD00005_USER_DIFF
	 [TMD00005_USER_DIFF(t, xx, wul)]
#endif /* TMD00005_USER_DIFF */
	 ];
  return dxx;
}


Func Matrix
output_tmd00005(t, xx, wul)
     Real t;
     Matrix xx, wul;
{
  Matrix x, w, u, z, y;
  Real delta10_tmd00005();

  x = chop_state_tmd00005(xx);
  w = chop_input_w_tmd00005(wul);
  u = chop_input_u_tmd00005(wul);

#ifndef TMD00005_DISABLE_HALIST
  if (halist(_TMD_LALIST, {_TMD_NOM_FLAG}) == {0}) // ѥ᡼ư
#else /* TMD00005_DISABLE_HALIST */
  if (tmd00005_flag == 0) // ѥ᡼ư
#endif /* ! TMD00005_DISABLE_HALIST */
    {
      z = tmd5(C1)*x + tmd5(D11)*w + tmd5(D12)*u;
      y = ((tmd5(C2) + [0,tmd5(C2)(2)*delta10_tmd00005(t)*tmd5(f10),0,0])*x
	   + tmd5(D21)*w + tmd5(D22)*u);
    }
  else // Υߥʥ
    {
      z = tmd5(C1)*x;
      y = (tmd5(C2) + [0,tmd5(C2)(2)*delta10_tmd00005(t)*tmd5(f10),0,0])*x;
    }

  return [[z][y]];
}

#undef tmd5
#undef _TMD_LALIST
#undef _TMD_NOM_FLAG

#endif /* !_TMD00005_MM */
